/*
 * Copyright (c) 2009 MIT Strategic Engineering Research Group
 * 
 * This file is part of SpaceNet 2.5.
 * 
 * SpaceNet 2.5 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SpaceNet 2.5 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SpaceNet 2.5.  If not, see <http://www.gnu.org/licenses/>.
 */
package edu.mit.spacenet.gui.command;

import edu.mit.spacenet.gui.data.DataSourceDialog;
import edu.mit.spacenet.gui.ScenarioPanel;

/**
 * The command to edit the data source of a scenario.
 * 
 * @author Paul Grogan
 */
public class EditDataSourceCommand implements I_Command {
	private ScenarioPanel scenarioPanel;
	
	/**
	 * The constructor.
	 * 
	 * @param scenarioPanel the scenario panel component
	 */
	public EditDataSourceCommand(ScenarioPanel scenarioPanel) {
		this.scenarioPanel=scenarioPanel;
	}
	
	/* (non-Javadoc)
	 * @see edu.mit.spacenet.gui.command.I_Command#execute()
	 */
	public void execute() {
		DataSourceDialog.createAndShowGUI(scenarioPanel);
	}
}