/*
 * Copyright (c) 2009 MIT Strategic Engineering Research Group
 * 
 * This file is part of SpaceNet 2.5.
 * 
 * SpaceNet 2.5 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SpaceNet 2.5 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SpaceNet 2.5.  If not, see <http://www.gnu.org/licenses/>.
 */
package edu.mit.spacenet.gui.command;

import javax.swing.JOptionPane;

import edu.mit.spacenet.gui.SpaceNetFrame;

/**
 * The command to exit the SpaceNet application.
 * 
 * @author Paul Grogan
 */
public class ExitCommand {
	private SpaceNetFrame spaceNetFrame;
	
	/**
	 * The constructor.
	 * 
	 * @param spaceNetFrame the SpaceNet frame
	 */
	public ExitCommand(SpaceNetFrame spaceNetFrame) {
		this.spaceNetFrame=spaceNetFrame;
	}
	
	/**
	 * Execute.
	 */
	public void execute() {
		if(spaceNetFrame.getScenarioPanel() != null) {
			int answer = JOptionPane.showOptionDialog(spaceNetFrame, 
					"Save " + spaceNetFrame.getScenarioPanel().getScenario().getName() + " before exiting?", 
					"Close Warning", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE, null, null, null);
		    if (answer == JOptionPane.YES_OPTION) {
		    	SaveScenarioCommand command = new SaveScenarioCommand(spaceNetFrame);
		    	command.execute();
		    	System.exit(0);
		    }
		    if (answer != JOptionPane.CANCEL_OPTION) System.exit(0);
		} else System.exit(0);
	}
}
