/*
 * Copyright (c) 2009 MIT Strategic Engineering Research Group
 * 
 * This file is part of SpaceNet 2.5.
 * 
 * SpaceNet 2.5 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SpaceNet 2.5 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SpaceNet 2.5.  If not, see <http://www.gnu.org/licenses/>.
 */
package edu.mit.spacenet.gui.command;

import javax.swing.JOptionPane;

import edu.mit.spacenet.gui.SpaceNetFrame;

/**
 * The command to open the SpaceNet help dialog.
 * 
 * @author Paul Grogan
 */
public class OpenHelpCommand implements I_Command {
	private SpaceNetFrame spaceNetFrame;
	
	/**
	 * Initializes a new open help command.
	 * 
	 * @param spaceNetFrame the SpaceNet frame
	 */
	public OpenHelpCommand(SpaceNetFrame spaceNetFrame) {
		this.spaceNetFrame=spaceNetFrame;
	}
	
	/* (non-Javadoc)
	 * @see edu.mit.spacenet.gui.command.I_Command#execute()
	 */
	public void execute() {
		JOptionPane.showMessageDialog(spaceNetFrame, "For help with SpaceNet, please see:\n\nSpaceNet User's Manual (docs/manual)\nQuick Start Tutorial (docs/tutorial)\nSpaceNet Website (http://spacenet.mit.edu)", 
				"SpaceNet Help", JOptionPane.PLAIN_MESSAGE);
	}
}